//AD.ADF_SWAP.REQUEST_MINMANNE = DB_adfswap_requestMinmanne.sh
//AD.ADF_SWAP.VALIDATE_MINMANNE = DB_adfswap_validateMinmanne.sh
//AD.ADF_SWAP.ADD_MM_ADDR = DB_adfswap_addMMAddress.sh
//AD.ADF_SWAP.GET_MM_PAYOUTS = DB_adfswap_getMMPayouts.sh

var MIDMANNE = {};
MIDMANNE.defaultTargetNodeNid="14270667173691107670";  //node that is the primary proivder of the ADF SWAP app.

//anne dev fund public key.
MIDMANNE.ADF_PUB_KEY = "7444e77e865970388bc20009cc8f571bfe466367319b3db5435d4fabb807e37f";
MIDMANNE.TARGET_NODE_PUB_KEY = "77f7571e3378c20c5f259a438a1650d50f9093025783022fc7cc127f8b802547";
MIDMANNE.ADF_NID = "7770353147211057540";
MIDMANNE.ref_codes = [];

MIDMANNE.commish_history = null;

MIDMANNE.max_cid = 0;               //highest commish record we have (query filter)
MIDMANNE.AH_LAST_CHG = 0;           //highest known last height of change record.
MIDMANNE.bch_node_online=false;
MIDMANNE.bch_node_synced=false;
MIDMANNE.bch_blocks=0;
MIDMANNE.annode_online = false;
MIDMANNE.annode_livemode = false;
MIDMANNE.annode_mode = null;
MIDMANNE.midmanne_id = 0;


MIDMANNE.mmObj = {
        midmanne_id:0, 
        midmanne_nid:"", 
        midmanne_onboards:0,
        midmanne_last_onboards_bonus_paid:0,
        midmanne_refc1:"",
        midmanne_refc2:"",
        midmanne_refc4:"",
        midmanne_refc5:"",
        midmanne_commish_rate_bps:"300",
        explore_tier:0,
        sales:0
}

MIDMANNE.sales_sum = 0;
MIDMANNE.commish_sum = 0;

//we only want these coms in this app for the ADF_SWAPS
MIDMANNE.subtypes = ["REQUEST_MINMANNE", "VALIDATE_MINMANNE", "ADD_MM_ADDR", "GET_MM_PAYOUTS"];

/**
 */
MIDMANNE.commish_scale = [
    {tier:0, neon:"yellow", nick:"Rookie", img:"0_rookie.jpg", sales:0, commish_bps:300},
     {tier:1, neon:"blue", nick:"Dealer", img:"1_dealer.jpg",sales:5000000, commish_bps:350},
     {tier:2, neon:"pink", nick:"Quota Crusher", img:"2_quotaCrusher.jpg",sales:10000000, commish_bps:400},
     {tier:3, neon:"orange", nick:"The Rainmaker", img:"3_rainmaker.jpg",sales:50000000, commish_bps:450},
     {tier:4, neon:"teal", nick:"The Doer", img:"4_doer.jpg",sales:100000000, commish_bps:500},
     {tier:5, neon:"pink", nick:"Revenue Radical", img:"5_revenueRadical.jpg",sales:200000000, commish_bps:550},
     {tier:6, neon:"teal", nick:"Swaps Guru", img:"6_swapsGuru.jpg",sales:300000000, commish_bps:600},
     {tier:7, neon:"pink", nick:"The Connoisseur", img:"7_connoisseur.jpg",sales:500000000, commish_bps:650},
     {tier:8, neon:"yellow", nick:"Numbers Ninja", img:"8_ninja.jpg",sales:1000000000, commish_bps:700},
     {tier:9, neon:"red", nick:"The Pitch Pirate", img:"9_pitchpirate.jpg",sales:5000000000, commish_bps:800},
     {tier:10, neon:"white", nick:"MIDMANNE Master", img:"10_master.jpg",sales:10000000000, commish_bps:1000}
];


MIDMANNE.getComishTier = function($annecoin) {
    var lastgood = MIDMANNE.commish_scale[0];
    lastgood.next = MIDMANNE.commish_scale[1];
    for (var c=1; c < MIDMANNE.commish_scale.length; c++) {
        var o = MIDMANNE.commish_scale[c];
        if ($annecoin >= o.sales) {
            lastgood = o;
            if (c+1 < MIDMANNE.commish_scale.length) lastgood.next = MIDMANNE.commish_scale[c+1];
            else lastgood.next = null;
        }
        else break;
    }
    return lastgood;
}


MIDMANNE.onboarder_bonuses = [
    {thresh:10, annecoin_bonus:20000},
    {thresh:20, annecoin_bonus:50000},
    {thresh:100, annecoin_bonus:1000000},
    {thresh:500, annecoin_bonus:10000000},
]

MIDMANNE.getOnboardNext=function($obs) {
    for (var b=0; b < MIDMANNE.onboarder_bonuses.length; b++) {
        var ob = MIDMANNE.onboarder_bonuses[b];
        if ($obs>ob.thresh) continue;
        return ob; 
    }
    return null;
}


MIDMANNE.setBCHStatus=function() {
    if (MIDMANNE.bch_node_online==true) {
        if (MIDMANNE.bch_node_synced==true) {
            var elbchstatus=ANNE.A.setHTML("bchnode_status", "LIVE");
            if (elbchstatus!=null) elbchstatus.classList="LIVE";
        }
        else {
            var elbchstatus=ANNE.A.setHTML("bchnode_status", "SYNC");
            if (elbchstatus!=null) elbchstatus.classList="SYNC";
        }
    }
    else {
        var elbchstatus=ANNE.A.setHTML("bchnode_status", "OFFLINE");
        if (elbchstatus!=null) elbchstatus.classList="OFFLINE";
    }
}


MIDMANNE.setPin = function() {
    ANNE.A.show("midmanne_set_activation_code");
    const input_mm_activation_code = document.getElementById("input_mm_activation_code");
    const btn_mm_activation_code = document.getElementById("btn_mm_activation_code");
    btn_mm_activation_code.addEventListener("click", async($e)=>{
        var ac = input_mm_activation_code.value.trim();
        MIDMANNE.validateAccessCode(MIDMANNE.defaultTargetNodeNid, ac);
    });


    input_mm_activation_code.addEventListener("input", ($e)=>{
        if (input_mm_activation_code.value.length>=4) ANNE.A.removeClass("btn_mm_activation_code", "disabled");
        else ANNE.A.addClass("btn_mm_activation_code", "disabled");
    });

    var pending = localStorage.getItem("mm_activation_pending");
    if (pending!=undefined && pending!=null && pending=="1") {
        var el = ANNE.A.emptyParent("btn_mm_request_access");
        el.innerHTML="Pending request.";
        MIDMANNE.midmanne_id = localStorage.getItem("midmanne_id");
        if (MIDMANNE.midmanne_id!=null) MIDMANNE.midmanne_id = parseInt(MIDMANNE.midmanne_id);
        return;
    }

    const btn_mm_request_access = document.getElementById("btn_mm_request_access");
    btn_mm_request_access.addEventListener("click", (e)=>{
        ANNE.A.hide(btn_mm_request_access);
        ANNE.A.show("request_access_form");
        ANNE.A.hide("midmanne_set_activation_code");
        const social_infos = document.getElementById("social_infos");
        const btn_mm_request = document.getElementById("btn_mm_request");
        btn_mm_request.addEventListener("click", (e)=>{
            //use alt-data-network to request access.
            //put a msg here to say request received.
            //we will contact at social media account.
            var socials = social_infos.value;
            console.log("submit alt data request ");
            console.log(socials);
            MIDMANNE.requestAccess(MIDMANNE.defaultTargetNodeNid, socials);
        });

        social_infos.addEventListener("input", (e)=>{
            if (social_infos.value.length>5) {
                ANNE.A.removeClass("btn_mm_request", "disabled");
            }
            else {
                ANNE.A.addClass("btn_mm_request", "disabled");
            }
        });
    });
}


/**
 * 
 */
MIDMANNE.init = async()=> {
    var midx = localStorage.getItem("midmanne_id");
    if (midx==null || midx==undefined) {
        localStorage.removeItem("midmanne_id");
        MIDMANNE.midmanne_id = "";
    }
    else {
        MIDMANNE.midmanne_id = parseInt(midx);
        ANNE.A.setHTML("mid_welcome", MIDMANNE.midmanne_id+"!");
    }
    console.log("init midmanne");
    ANNE.A.removeSelf("mm_intro");
    ANNE.A.show("main_refresh_div");
    MIDMANNE.addrEvents();
    

    var altaddr = localStorage.getItem("midmanne_altaddr");
    if (altaddr!=null) {
        var lu = localStorage.getItem("midmanne_payout_sum_lowest_unit");
        MIDMANNE.gui_addAddr({midmanne_altaddr:altaddr, midmanne_payout_sum_lowest_unit:lu});
    }

    const back_preview_btn = document.getElementById("back_preview_btn");
    back_preview_btn.addEventListener("click", (e)=>{
        var explore_tier = MIDMANNE.mmObj.explore_tier-1;
        console.log("explore tier:"+explore_tier);
        MIDMANNE.mmObj.explore_tier=MIDMANNE.mmObj.explore_tier-1;
        MIDMANNE.exploreMMTIERS(explore_tier);
    });
    const fwd_preview_btn = document.getElementById("fwd_preview_btn");
    fwd_preview_btn.addEventListener("click", (e)=>{
        var explore_tier = MIDMANNE.mmObj.explore_tier+1;
        console.log("explore tier:"+explore_tier);
        MIDMANNE.mmObj.explore_tier=MIDMANNE.mmObj.explore_tier+1;
        MIDMANNE.exploreMMTIERS(explore_tier);
    });

    var refresh_history_inner = document.getElementById("refresh_history_inner");
    refresh_history_inner.addEventListener("click", async(e)=>{
        ANNE.playSound("beep");
        ANNE.A.addClass("refresh_history_inner", "spinnerself");
        MIDMANNE.getCommishHistory(MIDMANNE.defaultTargetNodeNid);
    })

    if (ANNE.USER.isActivated()==false) await ANNE.USER.checkBalance(ANNE.USER._userNObj.nid);
    
    var ref1 = localStorage.getItem("mm_refcode1");
    if (ref1!=undefined && ref1!=null) MIDMANNE.ref_codes.push(ref1);

    var ref2 = localStorage.getItem("mm_refcode2");
    if (ref2!=undefined && ref2!=null) MIDMANNE.ref_codes.push(ref2);
    
    var ref3 = localStorage.getItem("mm_refcode3");
    if (ref3!=undefined && ref3!=null) MIDMANNE.ref_codes.push(ref3);
    
    var ref4 = localStorage.getItem("mm_refcode4");
    if (ref4!=undefined && ref4!=null) MIDMANNE.ref_codes.push(ref4);
    
    var ref5 = localStorage.getItem("mm_refcode5");
    if (ref5!=undefined && ref5!=null) MIDMANNE.ref_codes.push(ref5);
    
    var uri = "https://www.anne.network:9116/aon.html";
    var mm_uri = "https://www.anne.network:9116/midmanne.html";
    if (location.host.indexOf("localhost")!=-1){
        uri="";
        var parts = location.href.split("/");
        for (var p=0; p < parts.length-1; p++) {
            if (uri=="") uri+=parts[p];
            else uri+="/"+parts[p];
        }
        
        mm_uri = uri;

        uri+="/aon.html";
        mm_uri+="/midmanne.html";
    }

    for (var r=0; r < MIDMANNE.ref_codes.length; r++) {
        if (r==MIDMANNE.ref_codes.length-1) {
            ANNE.A.setHTML("ref"+(r+1), MIDMANNE.midmanne_id);
            ANNE.A.setHTML("ref"+(r+1)+"link", mm_uri+"?&ref_mid="+MIDMANNE.midmanne_id);
            ANNE.A.addCopyIco("ref"+(r+1)+"_copy", mm_uri+"?&ref_mid="+MIDMANNE.midmanne_id);
            continue;   
        }
        ANNE.A.setHTML("ref"+(r+1), MIDMANNE.ref_codes[r]);
        ANNE.A.setHTML("ref"+(r+1)+"link", uri+"?page=swaps&ref="+MIDMANNE.ref_codes[r]);
        ANNE.A.addCopyIco("ref"+(r+1)+"_copy", uri+"?page=swaps&ref="+MIDMANNE.ref_codes[r]);
    }
    
    ANNE.A.show("top_recap");
    ANNE.A.show("top_info");
    
    MIDMANNE.annode_mode = await ANNE.API.getAnnodeDetail("annode_mode");
    var el_status = ANNE.A.setHTML("annode_status", MIDMANNE.annode_mode.replace(" ", "-"));
    el_status.classList  = MIDMANNE.annode_mode;
    var last_anne_height = await ANNE.API.getAnnodeDetail("height");
    ANNE.A.setHTML("anne_height", last_anne_height);
    
    ANNE.A.show("mm_header_middle");

    //no need to load historic if they aren't a real user yet.
    //they can't have historic.
    MIDMANNE.doCommishTier(null);
    
    await MIDMANNE.loadHistoric();

    //get anything new.
    await MIDMANNE.getCommishHistory(MIDMANNE.defaultTargetNodeNid);
}


MIDMANNE.addrEvents=function() {
    const btn_add_bch = document.getElementById("btn_add_bch");
    const input_bch_addr = document.getElementById("input_bch_addr");
    const bch_addr_btn_submit = document.getElementById("bch_addr_btn_submit");
    const bch_addr_btn_cancel = document.getElementById("bch_addr_btn_cancel");
    bch_addr_btn_cancel.addEventListener("click", (e)=>{
        ANNE.A.hide(bch_addr_btn_submit);
        input_bch_addr.value="";
        ANNE.A.hide(input_bch_addr);
        ANNE.A.show(btn_add_bch);
        ANNE.A.hide(bch_addr_btn_cancel);
    });

    bch_addr_btn_submit.addEventListener("click", (e)=>{
        var altaddr = input_bch_addr.value.trim(); 
        if (altaddr.length<20) {
            alert("this is not likely a bch addr.");
            return;
        }
        MIDMANNE.addPayoutAddresses(MIDMANNE.defaultTargetNodeNid, "BCH", altaddr);
        ANNE.A.hide(bch_addr_btn_submit);
        ANNE.A.hide(btn_add_bch);
        ANNE.A.hide(input_bch_addr);
    });

    
    btn_add_bch.addEventListener("click", (e)=>{
        ANNE.A.show(input_bch_addr);
        ANNE.A.hide(btn_add_bch);
        ANNE.A.show(bch_addr_btn_submit);
        ANNE.A.show(bch_addr_btn_cancel);
    });
}

/**
 * 
 */
MIDMANNE.loadHistoric=async()=>{
    console.log("loadHistoric");
    MIDMANNE.commish_history = new arraymap("midmanne_commishid");
    var ch = await ANNE.DB_local.loadCommishHistory(ANNE.network);
    ANNE.A.show("commish_history_div");
    if (ch.length>0) {
        await MIDMANNE.processHistory(ch);
    }
    else MIDMANNE.doCommishTier(MIDMANNE.mmObj);
    return;
}

/**
 * 
 * @param {*} $ch 
 */
MIDMANNE.processHistory=async($ch)=>{
    console.log("processHistory");
    
    for (var c=0; c <$ch.length; c++) {
        var chobj = $ch[c];
        console.log(chobj);
        if (chobj.midmanne_id!==MIDMANNE.midmanne_id) continue;
        if (chobj.midmanne_nid!==ANNE.USER._userNObj.nid) continue;

        if (chobj.midmanne_commishid > MIDMANNE.max_cid) {
            MIDMANNE.max_cid = chobj.midmanne_commishid;
        }

        if (chobj.ah_last_chg > MIDMANNE.AH_LAST_CHG) {
            MIDMANNE.AH_LAST_CHG = chobj.ah_last_chg;
        }

        chobj.midmanne_clvl = parseInt(chobj.midmanne_clvl);
        
        //only tier1 sales count.
        //this calc'd number should vet out with our stored number 
        //in the minmanne record for this minmanne. (midmanne_annecoin_sales)
        if (chobj.midmanne_clvl==1) MIDMANNE.sales_sum+=chobj.midmanne_annecoin_sold;
        
        MIDMANNE.commish_sum+=chobj.midmanne_payout_commish_lu;
        MIDMANNE.gui_addHistory(chobj);
    }

    MIDMANNE.mmObj.sales = MIDMANNE.sales_sum;
    MIDMANNE.doCommishTier(MIDMANNE.mmObj);
}


/**
 * 
 * @returns 
 */
MIDMANNE.reconnectSocket=async()=>{
    //force resubscribe.. for testing (to be safe)
    //ANNE.SUBSCRIBER.bALTDATASOCKET_ON=false;
    if (ANNE.SUBSCRIBER.bALTDATASOCKET_ON==true) return;
    await ANNE.SUBSCRIBER.subscribeToAltData("ADF_SWAP", "", null, MIDMANNE.cb_swapdata);
}

MIDMANNE.getTicker=function($ticker){
    if ($ticker=="BCH") return "<img style='filter:grayscale(1);' width='12px' src='./imgs/coin_icos/BCH.png'></img>"
    else if ($ticker=="ANNE") return "<img width='12px' src='./imgs/coin_icos/ANNE.png'></img>"
    else if ($ticker=="USDT") return "<img width='12px' src='./imgs/coin_icos/USDT.png'></img>"
}


/**
 * 
 * @param {*} $tier 
 */
MIDMANNE.exploreMMTIERS=function($tier){
    var testmmobj = MIDMANNE.commish_scale[parseInt($tier)];
    if($tier<10) testmmobj.next = MIDMANNE.commish_scale[parseInt($tier+1)];
    MIDMANNE.doCommishTierTest(testmmobj);
}



/**
 * all swap data from sockets comes here.
 * @param {*} $json 
 * @returns 
 */
MIDMANNE.cb_swapdata =async($json)=>{
    if ($json.adtype!="ADF_SWAP") return;
    var subtype = $json.adsubtype;
    if (subtype && subtype.length>0) console.log("subtype:"+subtype);
    if (subtype==undefined) return;

    //not our com.
    if (MIDMANNE.subtypes.indexOf(subtype)==-1) return;

    var adpayload = $json.adpayload;
    if (adpayload==undefined || adpayload==null) return;

    //we have issues vetting this with encodings and java/js diffs.
    //it is vetted on the socket-sending annode.
    if ($json.RETURN_SIG!=undefined) {
    }


    if (adpayload.bch_node_online!=undefined && adpayload.bch_node_synced!=undefined) {
        MIDMANNE.bch_node_online=adpayload.bch_node_online;
        MIDMANNE.bch_node_synced=adpayload.bch_node_synced;
        MIDMANNE.bch_blocks=adpayload.blocks;
        MIDMANNE.setBCHStatus();
        ANNE.A.setHTML("BCH_blocks", MIDMANNE.bch_blocks);
    }
    

    var results=adpayload.results;

    if (adpayload.for_pubkey!=undefined 
        && adpayload.for_pubkey!=ANNE.USER._userLS.pubKey) {
        return;
    }
    var results2=null;

    if (results==undefined || results==null) {
        if (adpayload.data_string!=undefined && adpayload.nonce_string!=undefined) {
            //DECRYPT HERE.
            var privKeyHex = await ANNE.USER.getPrivKeyHex();
            if (privKeyHex==null) {
                alert("cannot decrypt msg, cannot ascertain private key");
                return;
            }
            var decrypted = await ANNE.USER.decryptJSONEncryptedFromANNODE(adpayload.nonce_string, adpayload.data_string, MIDMANNE.TARGET_NODE_PUB_KEY, privKeyHex);
            console.log(decrypted);
            results = decrypted.results;    //these are the history records
            results2 = decrypted.results2; //these are the adfmidmannage records.
            
            if (decrypted.bch_node_online!=undefined) {
                MIDMANNE.bch_node_online = decrypted.bch_node_online;
            }
            if (decrypted.bch_node_synced!=undefined) {
                MIDMANNE.bch_node_synced = decrypted.bch_node_synced;
            }
            if (decrypted.blocks!=undefined) {
                MIDMANNE.bch_blocks = decrypted.blocks;
            }
            MIDMANNE.setBCHStatus();
            ANNE.A.setHTML("BCH_blocks", MIDMANNE.bch_blocks);
            ANNE.A.removeClass("refresh_history_inner", "spinnerself");

            if ((results==undefined || results==null) 
               && (results2==undefined || results2==null)) {
                console.log("bail.");
                return;
            }
        }
        else return;
    }
    
    if (adpayload.bch_node_online!=undefined && adpayload.bch_node_synced!=undefined) {
        MIDMANNE.bch_node_online=adpayload.bch_node_online;
        MIDMANNE.bch_node_synced=adpayload.bch_node_synced;
        MIDMANNE.bch_blocks=adpayload.blocks;
        MIDMANNE.setBCHStatus();
        ANNE.A.setHTML("BCH_blocks", MIDMANNE.bch_blocks);
    }

    if (subtype=="REQUEST_MINMANNE") {
        console.log("a request for MINANNE signup has been received.");

        var rez = results[0];
        if (rez.midmanne_id!=undefined && rez.midmanne_id!=null) {
            var midmanne_id = parseInt(rez.midmanne_id);
            if (midmanne_id>0 && rez.midmanne_nid && rez.midmanne_nid==ANNE.USER._userNObj.nid) {
                localStorage.setItem("mm_activation_pending", "1");
                localStorage.setItem("midmanne_id", parseInt(midmanne_id));
                MIDMANNE.midmanne_id = parseInt(midmanne_id);
                ANNE.A.hide("pre_msg");
                ANNE.A.show("thankyou");
                ANNE.A.hide("request_access_form");
                //play hype vid?
            }
        }
    }


    //this has encrypted payload.  Will need to change the alt data network
    //to even handle it.
    else if (subtype=="VALIDATE_MINMANNE") {
        console.log("a request for MINANNE signup has been received.");
        var rez = results[0];
        if (rez!=null && rez!=undefined && rez.activated!=undefined) {
            var activated = rez.activated;
            if (rez.midmanne_nid==ANNE.USER._userNObj.nid) {
                if (activated=="1") {
                    localStorage.removeItem("mm_activation_pending");

                    if (MIDMANNE.midmanne_id==null || MIDMANNE.midmanne_id ==undefined) {
                        MIDMANNE.midmanne_id = parseInt(rez.midmanne_id);
                        if (localStorage.getItem("midmanne_id")==null) {
                            localStorage.setItem("midmanne_id", parseInt(rez.midmanne_id));
                        }
                    }

                    //validate mm code via alt data network, and wait.
                    var ac = input_mm_activation_code.value.trim();
                    localStorage.setItem("mm_activation_code", ac);
                    localStorage.setItem("mm_refcode1", rez.midmanne_refc1);
                    localStorage.setItem("mm_refcode2", rez.midmanne_refc2);
                    localStorage.setItem("mm_refcode3", rez.midmanne_refc3);
                    localStorage.setItem("mm_refcode4", rez.midmanne_refc4);
                    localStorage.setItem("mm_refcode5", rez.midmanne_refc5);
                    ANNE.A.removeSelf("mm_intro");
                    await MIDMANNE.init();
                }
                else {
                    console.warn("invalid activation code.");
                    alert("invalid activation code.  Please check your records and try again.");
                }
            }
        }
    }


    //add the record
    else if (subtype=="ADD_MM_ADDR") {
        ANNE.A.spinnerRemove("payaddress_spinner");
        for (var r=0; r < results.length; r++) {
            var rez=results[r];
            console.log(rez);
            MIDMANNE.gui_addAddr(rez);
        }
    }

    //these are not streaming -- they are requested.
    else if(subtype=="GET_MM_PAYOUTS" && (results!=null || results2!=null)) {
        console.log("MM PAYOUTS RECEIVED");
        ANNE.A.removeClass("refresh_history_inner", "spinnerself");

        if (results2!=null && results2.length) {
            console.log(results2);

            ANNE.A.empty("mm_stats_addresses");
            for (var r2=0; r2 < results2.length; r2++) {
                var r2obj = results2[r2];
                var aobj = new Object();

                if (r2obj.midmanne_nid!==ANNE.USER._userNObj.nid) continue;

                if ((MIDMANNE.midmanne_id==null || MIDMANNE.midmanne_id=="") && r2obj.midmanne_id) {
                    MIDMANNE.midmanne_id = parseInt(r2obj.midmanne_id);
                    if (localStorage.getItem("midmanne_id")==null) localStorage.setItem("midmanne_id", MIDMANNE.midmanne_id);
                    ANNE.A.setHTML("mid_welcome", MIDMANNE.midmanne_id+"!");
                    aobj.midmanne_id = r2obj.midmanne_id;
                }

                //wrong user.
                else if (r2obj.midmanne_id!=MIDMANNE.midmanne_id) {
                    continue;
                }

                aobj.midmanne_altaddr = r2obj.midmanne_altaddr;
                aobj.midmanne_ticker = r2obj.midmanne_ticker;
                aobj.midmanne_payout_sum_lowest_unit = r2obj.midmanne_payout_sum_lowest_unit;
                aobj.network = ANNE.network;

                if (aobj.midmanne_altaddr!=null) MIDMANNE.gui_addAddr(aobj);
            
                MIDMANNE.mmObj.midmanne_id = r2obj.midmanne_id;
                MIDMANNE.mmObj.midmanne_nid = r2obj.midmanne_nid;
                MIDMANNE.mmObj.midmanne_onboards = r2obj.midmanne_onboards;
                MIDMANNE.mmObj.midmanne_last_onboards_bonus_paid = r2obj.midmanne_last_onboards_bonus_paid;
                MIDMANNE.mmObj.midmanne_refc1 = r2obj.midmanne_refc1;
                MIDMANNE.mmObj.midmanne_refc2 = r2obj.midmanne_refc2;
                MIDMANNE.mmObj.midmanne_refc4 = r2obj.midmanne_refc4;
                MIDMANNE.mmObj.midmanne_refc5 = r2obj.midmanne_refc5;
                MIDMANNE.mmObj.midmanne_commish_rate_bps = r2obj.midmanne_commish_rate_bps;

                if (localStorage.getItem("mm_refcode1")==null)  {
                    localStorage.setItem("mm_refcode1", r2obj.midmanne_refc1);
                }
                if (localStorage.getItem("mm_refcode2")==null)  {
                    localStorage.setItem("mm_refcode2", r2obj.midmanne_refc2);
                }
                if (localStorage.getItem("mm_refcode3")==null)  {
                    localStorage.setItem("mm_refcode3", r2obj.midmanne_refc3);
                }
                if (localStorage.getItem("mm_refcode4")==null)  {
                    localStorage.setItem("mm_refcode4", r2obj.midmanne_refc4);
                }
                if (localStorage.getItem("mm_refcode5")==null)  {
                    localStorage.setItem("mm_refcode5", r2obj.midmanne_refc5);
                }
                
            }    

            if (MIDMANNE.mmObj!=null) {
                MIDMANNE.gui_dostats(MIDMANNE.mmObj);
            }
        }

        if (results==null) return;
        var updates = [];
        var adds = [];
        for (var r=0; r < results.length; r++) {
            var rez = results[r];
            if(MIDMANNE.commish_history.contains(rez.midmanne_commishid)==true) {
                updates.push(rez);
            }
            else {
                adds.push(rez);
            }
        }

        if (adds.length>0) {
            await ANNE.DB_local.___insert(adds, "otc_commish");
            MIDMANNE.processHistory(adds);
        }
    
    
        //update in db, and on-screen.
        if (updates.length>0) {
            console.log("updates: "+updates.length);
            await ANNE.DB_local.___updateAll(updates, "otc_commish");
            for (var u=0; u < updates.length; u++) {
                var el_chi = document.getElementById("commish_history_inner");
                if (el_chi==null) {
                    return;
                }

                var el_ch = document.getElementById("ch_"+updates[u].midmanne_commishid);
                if (el_ch==null) {
                    console.log("commish record ch_"+updates[u].midmanne_commishid+" not found?");
                    MIDMANNE.gui_addHistory(updates[u]);
                    return;
                }
                ANNE.A.removeSelf(el_ch);   //remove then add it back..
                MIDMANNE.gui_addHistory(updates[u]);
            }
        }
    }
}



/**
 * 
 * @param {*} $statsObj 
 */
MIDMANNE.gui_dostats = function($statsObj) {
    console.log("do stats");
    ANNE.A.setHTML("stat_commish_bps", $statsObj.midmanne_commish_rate_bps/100+"%");
    
    MIDMANNE.doCommishTier(MIDMANNE.mmObj);
}

MIDMANNE.doCommishTierTest=function($mmObj){
    if ($mmObj.tier==0) {
        ANNE.A.hide("back_preview_btn");
        ANNE.A.show("fwd_preview_btn");
    }
    else if ($mmObj.tier==10) {
        ANNE.A.show("back_preview_btn");
        ANNE.A.hide("fwd_preview_btn");
    }
    else {
        ANNE.A.show("back_preview_btn");
        ANNE.A.show("fwd_preview_btn");
    }

    var elneo = document.getElementById("mm_stats");
    elneo.classList = "mm-stats neontile "+$mmObj.neon;

    var per = document.getElementById("stat_commish_bps");
    per.classList = $mmObj.neon+"-tier";

    var mmtier = document.getElementById("mmtier");
    mmtier.classList = "tier "+$mmObj.neon+"-tier";

    ANNE.A.setHTML("mmtier", "level "+$mmObj.tier);
    ANNE.A.setHTML("tier_nick", $mmObj.nick);
    var elbg = document.getElementById("mm_lvl_avatar");
    elbg.style["background-image"] = 'url("./imgs/midmanne_avatars/'+$mmObj.img+'")';
    ANNE.A.setHTML("stat_commish_bps", $mmObj.commish_bps/100+"%");
    ANNE.A.setHTML("stat_total_sales", ANNE.UTILS.commas($mmObj.sales)+MIDMANNE.getTicker("ANNE"));
    ANNE.A.setHTML("stat_total_commish", "");
    
    //we're all out!  WOH!
    if ($mmObj.next==undefined || $mmObj.next==null) {
        ANNE.A.hideParent("stat_commish_next_sales_lvl");
    } 
    else {
        ANNE.A.showParent("stat_commish_next_sales_lvl");
        ANNE.A.setHTML("stat_commish_next_bps", $mmObj.next.commish_bps/100+"%");
        ANNE.A.setHTML("stat_commish_next_sales_lvl", ANNE.UTILS.commas($mmObj.next.sales)+MIDMANNE.getTicker("ANNE"));
    }

    
    ANNE.A.hide("stat_onboards"); 
    ANNE.A.hide("stat_last_onboards_bonus_paid");
    ANNE.A.hide("stat_onboards_next");
    ANNE.A.hide("stat_onboards_next_value");
    
}


/**
 * 
 * @param {*} $mmObj 
 */
MIDMANNE.doCommishTier = function($mmObj=null) {
    var ct = MIDMANNE.getComishTier(MIDMANNE.sales_sum);
    if (ct.tier==0) {
        ANNE.A.hide("back_preview_btn");
        ANNE.A.show("fwd_preview_btn");
    }
    else if (ct.tier==10) {
        ANNE.A.show("back_preview_btn");
        ANNE.A.hide("fwd_preview_btn");
    }
    else {
        ANNE.A.show("back_preview_btn");
        ANNE.A.show("fwd_preview_btn");
    }

    var elneo = document.getElementById("mm_stats");
    elneo.classList = "mm-stats neontile "+ct.neon;

    if ($mmObj!=null) {
        var per = document.getElementById("stat_commish_bps");
        per.classList = $mmObj.neon+"-tier";

        var mmtier = document.getElementById("mmtier");
        mmtier.classList = "tier "+$mmObj.neon+"-tier";
    }
    
    console.log("commish tier:", ct);
    ANNE.A.setHTML("mmtier", "level "+ct.tier);
    ANNE.A.setHTML("tier_nick", ct.nick);
    var elbg = document.getElementById("mm_lvl_avatar");
    elbg.style["background-image"] = 'url("./imgs/midmanne_avatars/'+ct.img+'")';
    ANNE.A.setHTML("stat_commish_bps", ct.commish_bps/100+"%");
    ANNE.A.setHTML("stat_total_sales", ANNE.UTILS.commas(MIDMANNE.sales_sum)+MIDMANNE.getTicker("ANNE"));
    ANNE.A.setHTML("stat_total_commish", ANNE.UTILS.commas(MIDMANNE.commish_sum)+MIDMANNE.getTicker("BCH")+"<span class='lblsats'>sats</span>");
    
    //we're all out!  WOH!
    if (ct.next==null) {
        ANNE.A.hideParent("stat_commish_next_sales_lvl");
    } 
    else {
        ANNE.A.showParent("stat_commish_next_sales_lvl");
        ANNE.A.setHTML("stat_commish_next_bps", ct.next.commish_bps/100+"%");
        ANNE.A.setHTML("stat_commish_next_sales_lvl", ANNE.UTILS.commas(ct.next.sales)+MIDMANNE.getTicker("ANNE"));
    }

    if ($mmObj!=null) {
        ANNE.A.setHTML("stat_onboards", $mmObj.midmanne_onboards, true); 
        ANNE.A.setHTML("stat_last_onboards_bonus_paid", ANNE.UTILS.commas( $mmObj.midmanne_last_onboards_bonus_paid), true)+MIDMANNE.getTicker("ANNE");
        var nextob = MIDMANNE.getOnboardNext($mmObj.midmanne_onboards, true);
        ANNE.A.setHTML("stat_onboards_next", nextob.thresh, true);
        ANNE.A.setHTML("stat_onboards_next_value", ANNE.UTILS.commas(nextob.annecoin_bonus),true)+MIDMANNE.getTicker("ANNE");
    }
    else {
        ANNE.A.setHTML("stat_onboards", "0", true); 
        ANNE.A.setHTML("stat_last_onboards_bonus_paid", "0", true);
        ANNE.A.setHTML("stat_onboards_next", MIDMANNE.onboarder_bonuses[0].thresh, true);
        ANNE.A.setHTML("stat_onboards_next_value", ANNE.UTILS.commas(MIDMANNE.onboarder_bonuses[0].annecoin_bonus), true)+MIDMANNE.getTicker("ANNE");
    }

    //"stat_unpaid_commish" 
    //"collect_unpaid_now" 

}


/**
 * 
 * @param {*} $hobj 
 */
MIDMANNE.gui_addAddr = function($hobj) {
    ANNE.A.removeSelf("payoutaddr_header");

    var el_addrs = document.getElementById("mm_stats_addresses");
    ANNE.A.empty("mm_stats_addresses");

    var addel = document.createElement("div");
    addel.classList="commish-addr-row";
    el_addrs.appendChild(addel);
    
    var spaltaddr = document.createElement("span");
    spaltaddr.classList="commish-altaddr";
    spaltaddr.innerHTML = $hobj.midmanne_altaddr;
    localStorage.setItem("midmanne_altaddr", $hobj.midmanne_altaddr);
    addel.appendChild(spaltaddr);

    var sppayouts = document.createElement("span");
    sppayouts.classList="commish-commish";
    localStorage.setItem("midmanne_payout_sum_lowest_unit", $hobj.midmanne_payout_sum_lowest_unit);
    sppayouts.innerHTML = "<span class='lblpaid'>total paid</span><span class='commishpaid'>"+ANNE.UTILS.commas($hobj.midmanne_payout_sum_lowest_unit)+"</span>"+MIDMANNE.getTicker("BCH")+"<span class='lblsats'>sats</span>";
    addel.appendChild(sppayouts);

    //no more bch address adds.
    ANNE.A.removeSelf("add_bch");
}



/**
 * 
 * @param {*} $chobj 
 * @returns 
 */
MIDMANNE.gui_addHistory = function($chobj) {
    var el_ch = document.getElementById("commish_history_inner");
    if (el_ch==null) {
        return;
    }
    var divhist = document.createElement("div");
    divhist.setAttribute("id", "ch_"+$chobj.midmanne_commishid);
    divhist.setAttribute("cid", $chobj.midmanne_commishid);
    divhist.classList = "commish-history";
    el_ch.prepend(divhist);

    var splvl = document.createElement("span");
    splvl.classList="commish-lvl-"+$chobj.midmanne_clvl;
    splvl.innerHTML = "level "+$chobj.midmanne_clvl;
    divhist.appendChild(splvl);

    var spsale = document.createElement("span");
    spsale.classList="commish-sale";
    spsale.innerHTML = "<span class='lbl-white'>sale</span>"+ANNE.UTILS.commas($chobj.midmanne_annecoin_sold)+MIDMANNE.getTicker("ANNE");
    divhist.appendChild(spsale);

    var spbps = document.createElement("span");
    spbps.classList="commish-bps";
    spbps.innerHTML = "<span class='lbl-white'>commission</span>"+ANNE.UTILS.commas($chobj.midmanne_commish_bps/100)+" %";
    divhist.appendChild(spbps);

    var spcommish = document.createElement("div");
    spcommish.classList="commish-commish";
    var commish = $chobj.midmanne_payout_commish_lu;
    //if ($chobj.midmanne_clvl==2) commish = commish * 0.10;
    spcommish.innerHTML = commish+" "+MIDMANNE.getTicker($chobj.midmanne_payout_ticker)+" <span class='lblsats'>sats</span>";
    divhist.appendChild(spcommish);


    //midmanne_onboarding now is the MID of who got onboarded, if any, else 0.
    if ($chobj.midmanne_onboarding!="0" && $chobj.midmanne_onboarding!=0) {
        var spob = document.createElement("span");
        spob.classList="commish-onboarding";
        spob.innerHTML = "onboarding +1 (m:"+$chobj.midmanne_onboarding+")";
        divhist.appendChild(spob);
    }


    if ($chobj.midmanne_txid_alt==null || $chobj.midmanne_txid_alt==undefined || $chobj.midmanne_txid_alt=="") {
        var col = document.createElement("span");
        col.classList="collect-now";
        col.innerHTML="not collected";
        col.style="margin-left:4px;";
        col.title="click to collect!";
        divhist.appendChild(col);
        col.addEventListener("click", (e)=>{
            alert("collect");
        });
    }
    else {
        var col = document.createElement("span");
        col.classList="collected";
        col.innerHTML="collected";
        col.style="margin-left:4px;";
        col.title="txid:"+$chobj.midmanne_txid_alt+" on bch!";
        col.setAttribute("txid", $chobj.midmanne_txid_alt);
        divhist.appendChild(col);
        col.addEventListener("click", (e)=>{
            var txid = e.target.getAttribute("txid")
            ANNE.UTILS.copyToClipboard(txid); 
            ANNE.playSound("click");
        });
       
    }
}




/**
 * This ensures the minmanne is indeed using the right code.
 * @param {*} $targetNodeNid 
 * @param {*} $access_code 
 * @returns 
 */
MIDMANNE.validateAccessCode=async($targetNodeNid="", $access_code)=>{

    if (ANNE.USER._userNObj.nid==0) {
        alert("can't use nid=0 here.  MUST HAVE NID");
        return;
    }

    await MIDMANNE.reconnectSocket();
    if ($targetNodeNid==undefined || $targetNodeNid==null || $targetNodeNid=="") {
        $targetNodeNid=MIDMANNE.defaultTargetNodeNid;
    }

    var encrypted_payload = await ANNE.ALTDATA.encryptPlain($access_code, MIDMANNE.TARGET_NODE_PUB_KEY);

    //user_sig_data:eObj.data_string,
	//user_sig_nonce:eObj.nonce_string,
    if (encrypted_payload==null) {
        console.warn("encryption problem, cannot continue");
        return;
    }
     
    var adpayload = {
        adid:ANNE.UTILS.randHex(12),
        encrypted_payload:encrypted_payload,
        targetNodeNid:$targetNodeNid,
        user_nid:ANNE.USER._userNObj.nid,
        zpropagate:false,
        zreq_sig:true,
        zzzzret_targetNodeNid:ANNE._annodesLS.last_nid
    }
    var pObj = await ANNE.ALTDATA.signMsg(adpayload);   //this will inject pubkey.
    if (pObj==null) {
        console.warn("signing problem");
        return null;
    }

    var adtype = "ADF_SWAP";
    var adsubtype = "VALIDATE_MINMANNE";
    var rez = await ANNE.API.sendAltData(adtype, adsubtype, pObj.payloadstring, pObj.sig);
    return rez;
}


/**
 * Access will be tied to anne_nid and a new minmanne_id (for privacy).
 * 
 * minmanne user will later (in another function) set their alt_address 
 * for payouts.
 * 
 * @param {*} $targetNodeNid 
 * @param {*} $socials_desc 
 * @returns 
 */
MIDMANNE.requestAccess=async($targetNodeNid="", $socials_desc="")=>{
    if (ANNE.USER._userNObj.nid==0) {
        alert("USER.nid MUST BE SET");
        return null;
    }
    await MIDMANNE.reconnectSocket();

    if ($targetNodeNid==undefined || $targetNodeNid==null || $targetNodeNid=="") {
        $targetNodeNid=MIDMANNE.defaultTargetNodeNid;
    }

    if (ANNE.ref_mid==undefined || ANNE.ref_mid==null) {
        ANNE.ref_mid=0;
    }

    if (ANNE.ref_mid==0) {
        var rn = localStorage.getItem("ref_mid");
        if (rn!=null) {
            console.log("WTF FIX");
            ANNE.ref_mid=rn;
        }
    }

    console.warn("ref_mid:"+ANNE.ref_mid);

    var adpayload = {
        adid:ANNE.UTILS.randHex(12),
        ref_mid:ANNE.ref_mid,
        socials_desc:$socials_desc,
        targetNodeNid:$targetNodeNid,
        user_nid:ANNE.USER._userNObj.nid,
        zpropagate:false,
        zreq_sig:true,
        zzzzret_targetNodeNid:ANNE._annodesLS.last_nid
    }

    var pObj = await ANNE.ALTDATA.signMsg(adpayload);
    if (pObj==null) {
        console.warn("signing problem");
        return null;
    }

    var adtype = "ADF_SWAP";
    var adsubtype = "REQUEST_MINMANNE";
    var rez = await ANNE.API.sendAltData(adtype, adsubtype, pObj.payloadstring, pObj.sig);
    return rez;
}


/**
 * We want the history, with a filter (preserve data/bandwidth/waste)
 * This also needs to be ENCRYPTED TO US.
 * We will decrypt on this side.
 * @param {*} $targetNodeNid 
 * @returns 
 */
MIDMANNE.getCommishHistory=async($targetNodeNid="")=>{
    console.log("getCommishHistory");
    await MIDMANNE.reconnectSocket();
    if ($targetNodeNid==undefined || $targetNodeNid==null || $targetNodeNid=="") {
        $targetNodeNid=MIDMANNE.defaultTargetNodeNid;
    }

    var upkb = "0";
    if (ANNE.USER.isActivated()==false) {
        upkb="1";
    }

    console.log("query using filter_cid:"+MIDMANNE.max_cid);

    var adpayload = {
        adid:ANNE.UTILS.randHex(12),
        ah_last_chg:MIDMANNE.AH_LAST_CHG,
        filter_cid:MIDMANNE.max_cid,
        targetNodeNid:$targetNodeNid,
        user_nid:ANNE.USER._userNObj.nid,
        user_pub_key_back:upkb,
        zpropagate:false,
        zreq_sig:true,
        zzzzret_targetNodeNid:ANNE._annodesLS.last_nid,
        zzzzz_encrypt_return:true
    }

    var pObj = await ANNE.ALTDATA.signMsg(adpayload);   //this will inject pubkey.
    if (pObj==null) {
        console.warn("signing problem");
        return null;
    }

    console.log(pObj);

    var adtype = "ADF_SWAP";
    var adsubtype = "GET_MM_PAYOUTS";
    var rez = await ANNE.API.sendAltData(adtype, adsubtype, pObj.payloadstring, pObj.sig);
    return rez;
}


/**
 * 
 * @param {*} $targetNodeNid 
 * @param {*} $ticker 
 * @param {*} $altaddr 
 * @returns 
 */
MIDMANNE.addPayoutAddresses=async($targetNodeNid="", $ticker, $altaddr)=>{
    await MIDMANNE.reconnectSocket();

    ANNE.A.spinnerInject("payaddress_spinner");

    if ($targetNodeNid==undefined || $targetNodeNid==null || $targetNodeNid=="") {
        $targetNodeNid=MIDMANNE.defaultTargetNodeNid;
    }
    var adpayload = {
        adid:ANNE.UTILS.randHex(12),
        altaddr:$altaddr,
        targetNodeNid:$targetNodeNid,
        ticker:$ticker,
        user_nid:ANNE.USER._userNObj.nid,
        zpropagate:false,
        zreq_sig:true,
        zzzzret_targetNodeNid:ANNE._annodesLS.last_nid,
        zzzzz_encrypt_return:true
    }

    var pObj = await ANNE.ALTDATA.signMsg(adpayload);   //this will inject pubkey.
    if (pObj==null) {
        console.warn("signing problem");
        return null;
    }

    var adtype = "ADF_SWAP";
    var adsubtype = "ADD_MM_ADDR";
    var rez = await ANNE.API.sendAltData(adtype, adsubtype, pObj.payloadstring, pObj.sig);
    return rez;
}
